/*!
 * # Semantic UI 2.2.13 - Modal
 * http://github.com/semantic-org/semantic-ui/
 *
 *
 * Released under the MIT license
 * http://opensource.org/licenses/MIT
 *
 */
!function(e,i,n,t){"use strict";i="undefined"!=typeof i&&i.Math==Math?i:"undefined"!=typeof self&&self.Math==Math?self:Function("return this")(),e.fn.modal=function(o){var a,r=e(this),s=e(i),c=e(n),l=e("body"),d=r.selector||"",u=(new Date).getTime(),m=[],f=arguments[0],g="string"==typeof f,h=[].slice.call(arguments,1),v=i.requestAnimationFrame||i.mozRequestAnimationFrame||i.webkitRequestAnimationFrame||i.msRequestAnimationFrame||function(e){setTimeout(e,0)};return r.each(function(){var r,b,p,y,k,w,C,S,M,H=e.isPlainObject(o)?e.extend(!0,{},e.fn.modal.settings,o):e.extend({},e.fn.modal.settings),F=H.selector,T=H.className,A=H.namespace,D=H.error,x="."+A,O="module-"+A,z=e(this),q=e(H.context),E=z.find(F.close),j=this,N=z.data(O),P=!1;M={initialize:function(){M.verbose("Initializing dimmer",q),M.create.id(),M.create.dimmer(),M.refreshModals(),M.bind.events(),H.observeChanges&&M.observeChanges(),M.instantiate()},instantiate:function(){M.verbose("Storing instance of modal"),N=M,z.data(O,N)},create:{dimmer:function(){var i={debug:H.debug,dimmerName:"modals"},n=e.extend(!0,i,H.dimmerSettings);return e.fn.dimmer===t?void M.error(D.dimmer):(M.debug("Creating dimmer"),y=q.dimmer(n),H.detachable?(M.verbose("Modal is detachable, moving content into dimmer"),y.dimmer("add content",z)):M.set.undetached(),void(k=y.dimmer("get dimmer")))},id:function(){C=(Math.random().toString(16)+"000000000").substr(2,8),w="."+C,M.verbose("Creating unique id for element",C)}},destroy:function(){M.verbose("Destroying previous modal"),z.removeData(O).off(x),s.off(w),k.off(w),E.off(x),q.dimmer("destroy")},observeChanges:function(){"MutationObserver"in i&&(S=new MutationObserver(function(e){M.debug("DOM tree modified, refreshing"),M.refresh()}),S.observe(j,{childList:!0,subtree:!0}),M.debug("Setting up mutation observer",S))},refresh:function(){M.remove.scrolling(),M.cacheSizes(),M.set.screenHeight(),M.set.type(),M.set.position()},refreshModals:function(){b=z.siblings(F.modal),r=b.add(z)},attachEvents:function(i,n){var t=e(i);n=e.isFunction(M[n])?M[n]:M.toggle,t.length>0?(M.debug("Attaching modal events to element",i,n),t.off(x).on("click"+x,n)):M.error(D.notFound,i)},bind:{events:function(){M.verbose("Attaching events"),z.on("click"+x,F.close,M.event.close).on("click"+x,F.approve,M.event.approve).on("click"+x,F.deny,M.event.deny),s.on("resize"+w,M.event.resize)}},get:{id:function(){return(Math.random().toString(16)+"000000000").substr(2,8)}},event:{approve:function(){return P||H.onApprove.call(j,e(this))===!1?void M.verbose("Approve callback returned false cancelling hide"):(P=!0,void M.hide(function(){P=!1}))},deny:function(){return P||H.onDeny.call(j,e(this))===!1?void M.verbose("Deny callback returned false cancelling hide"):(P=!0,void M.hide(function(){P=!1}))},close:function(){M.hide()},click:function(i){var t=e(i.target),o=t.closest(F.modal).length>0,a=e.contains(n.documentElement,i.target);!o&&a&&(M.debug("Dimmer clicked, hiding all modals"),M.is.active()&&(M.remove.clickaway(),H.allowMultiple?M.hide():M.hideAll()))},debounce:function(e,i){clearTimeout(M.timer),M.timer=setTimeout(e,i)},keyboard:function(e){var i=e.which,n=27;i==n&&(H.closable?(M.debug("Escape key pressed hiding modal"),M.hide()):M.debug("Escape key pressed, but closable is set to false"),e.preventDefault())},resize:function(){y.dimmer("is active")&&(M.is.animating()||M.is.active())&&v(M.refresh)}},toggle:function(){M.is.active()||M.is.animating()?M.hide():M.show()},show:function(i){i=e.isFunction(i)?i:function(){},M.refreshModals(),M.set.dimmerSettings(),M.showModal(i)},hide:function(i){i=e.isFunction(i)?i:function(){},M.refreshModals(),M.hideModal(i)},showModal:function(i){i=e.isFunction(i)?i:function(){},M.is.animating()||!M.is.active()?(M.showDimmer(),M.cacheSizes(),M.set.position(),M.set.screenHeight(),M.set.type(),M.set.clickaway(),!H.allowMultiple&&M.others.active()?M.hideOthers(M.showModal):(H.allowMultiple&&H.detachable&&z.detach().appendTo(k),H.onShow.call(j),H.transition&&e.fn.transition!==t&&z.transition("is supported")?(M.debug("Showing modal with css animations"),z.transition({debug:H.debug,animation:H.transition+" in",queue:H.queue,duration:H.duration,useFailSafe:!0,onComplete:function(){H.onVisible.apply(j),H.keyboardShortcuts&&M.add.keyboardShortcuts(),M.save.focus(),M.set.active(),H.autofocus&&M.set.autofocus(),i()}})):M.error(D.noTransition))):M.debug("Modal is already visible")},hideModal:function(i,n){return i=e.isFunction(i)?i:function(){},M.debug("Hiding modal"),H.onHide.call(j,e(this))===!1?void M.verbose("Hide callback returned false cancelling hide"):void((M.is.animating()||M.is.active())&&(H.transition&&e.fn.transition!==t&&z.transition("is supported")?(M.remove.active(),z.transition({debug:H.debug,animation:H.transition+" out",queue:H.queue,duration:H.duration,useFailSafe:!0,onStart:function(){M.others.active()||n||M.hideDimmer(),H.keyboardShortcuts&&M.remove.keyboardShortcuts()},onComplete:function(){H.onHidden.call(j),M.restore.focus(),i()}})):M.error(D.noTransition)))},showDimmer:function(){y.dimmer("is animating")||!y.dimmer("is active")?(M.debug("Showing dimmer"),y.dimmer("show")):M.debug("Dimmer already visible")},hideDimmer:function(){return y.dimmer("is animating")||y.dimmer("is active")?void y.dimmer("hide",function(){M.remove.clickaway(),M.remove.screenHeight()}):void M.debug("Dimmer is not visible cannot hide")},hideAll:function(i){var n=r.filter("."+T.active+", ."+T.animating);i=e.isFunction(i)?i:function(){},n.length>0&&(M.debug("Hiding all visible modals"),M.hideDimmer(),n.modal("hide modal",i))},hideOthers:function(i){var n=b.filter("."+T.active+", ."+T.animating);i=e.isFunction(i)?i:function(){},n.length>0&&(M.debug("Hiding other modals",b),n.modal("hide modal",i,!0))},others:{active:function(){return b.filter("."+T.active).length>0},animating:function(){return b.filter("."+T.animating).length>0}},add:{keyboardShortcuts:function(){M.verbose("Adding keyboard shortcuts"),c.on("keyup"+x,M.event.keyboard)}},save:{focus:function(){p=e(n.activeElement).blur()}},restore:{focus:function(){p&&p.length>0&&p.focus()}},remove:{active:function(){z.removeClass(T.active)},clickaway:function(){H.closable&&k.off("click"+w)},bodyStyle:function(){""===l.attr("style")&&(M.verbose("Removing style attribute"),l.removeAttr("style"))},screenHeight:function(){M.debug("Removing page height"),l.css("height","")},keyboardShortcuts:function(){M.verbose("Removing keyboard shortcuts"),c.off("keyup"+x)},scrolling:function(){y.removeClass(T.scrolling),z.removeClass(T.scrolling)}},cacheSizes:function(){z.addClass(T.loading);var o=z.prop("scrollHeight"),a=z.outerHeight();M.cache!==t&&0===a||(M.cache={pageHeight:e(n).outerHeight(),height:a+H.offset,scrollHeight:o+H.offset,contextHeight:"body"==H.context?e(i).height():y.height()},M.cache.topOffset=-(M.cache.height/2)),z.removeClass(T.loading),M.debug("Caching modal and container sizes",M.cache)},can:{fit:function(){var e=M.cache.contextHeight,i=M.cache.contextHeight/2,n=M.cache.topOffset,t=M.cache.scrollHeight,o=M.cache.height,a=H.padding,r=i+n;return t>o?r+t+a<e:o+2*a<e}},is:{active:function(){return z.hasClass(T.active)},animating:function(){return z.transition("is supported")?z.transition("is animating"):z.is(":visible")},scrolling:function(){return y.hasClass(T.scrolling)},modernBrowser:function(){
// appName for IE11 reports 'Netscape' can no longer use
return!(i.ActiveXObject||"ActiveXObject"in i)}},set:{autofocus:function(){var e=z.find("[tabindex], :input").filter(":visible"),i=e.filter("[autofocus]"),n=i.length>0?i.first():e.first();n.length>0&&n.focus()},clickaway:function(){H.closable&&k.on("click"+w,M.event.click)},dimmerSettings:function(){if(e.fn.dimmer===t)return void M.error(D.dimmer);var i={debug:H.debug,dimmerName:"modals",variation:!1,closable:"auto",duration:{show:H.duration,hide:H.duration}},n=e.extend(!0,i,H.dimmerSettings);H.inverted?(n.variation=n.variation!==t?n.variation+" inverted":"inverted",k.addClass(T.inverted)):k.removeClass(T.inverted),H.blurring?y.addClass(T.blurring):y.removeClass(T.blurring),q.dimmer("setting",n)},screenHeight:function(){M.can.fit()?l.css("height",""):(M.debug("Modal is taller than page content, resizing page height"),l.css("height",M.cache.height+2*H.padding))},active:function(){z.addClass(T.active)},scrolling:function(){y.addClass(T.scrolling),z.addClass(T.scrolling)},type:function(){M.can.fit()?(M.verbose("Modal fits on screen"),M.others.active()||M.others.animating()||M.remove.scrolling()):(M.verbose("Modal cannot fit on screen setting to scrolling"),M.set.scrolling())},position:function(){M.verbose("Centering modal on page",M.cache),M.can.fit()?z.css({top:"",marginTop:M.cache.topOffset}):z.css({marginTop:"",top:c.scrollTop()})},undetached:function(){y.addClass(T.undetached)}},setting:function(i,n){if(M.debug("Changing setting",i,n),e.isPlainObject(i))e.extend(!0,H,i);else{if(n===t)return H[i];e.isPlainObject(H[i])?e.extend(!0,H[i],n):H[i]=n}},internal:function(i,n){if(e.isPlainObject(i))e.extend(!0,M,i);else{if(n===t)return M[i];M[i]=n}},debug:function(){!H.silent&&H.debug&&(H.performance?M.performance.log(arguments):(M.debug=Function.prototype.bind.call(console.info,console,H.name+":"),M.debug.apply(console,arguments)))},verbose:function(){!H.silent&&H.verbose&&H.debug&&(H.performance?M.performance.log(arguments):(M.verbose=Function.prototype.bind.call(console.info,console,H.name+":"),M.verbose.apply(console,arguments)))},error:function(){H.silent||(M.error=Function.prototype.bind.call(console.error,console,H.name+":"),M.error.apply(console,arguments))},performance:{log:function(e){var i,n,t;H.performance&&(i=(new Date).getTime(),t=u||i,n=i-t,u=i,m.push({Name:e[0],Arguments:[].slice.call(e,1)||"",Element:j,"Execution Time":n})),clearTimeout(M.performance.timer),M.performance.timer=setTimeout(M.performance.display,500)},display:function(){var i=H.name+":",n=0;u=!1,clearTimeout(M.performance.timer),e.each(m,function(e,i){n+=i["Execution Time"]}),i+=" "+n+"ms",d&&(i+=" '"+d+"'"),(console.group!==t||console.table!==t)&&m.length>0&&(console.groupCollapsed(i),console.table?console.table(m):e.each(m,function(e,i){console.log(i.Name+": "+i["Execution Time"]+"ms")}),console.groupEnd()),m=[]}},invoke:function(i,n,o){var r,s,c,l=N;return n=n||h,o=j||o,"string"==typeof i&&l!==t&&(i=i.split(/[\. ]/),r=i.length-1,e.each(i,function(n,o){var a=n!=r?o+i[n+1].charAt(0).toUpperCase()+i[n+1].slice(1):i;if(e.isPlainObject(l[a])&&n!=r)l=l[a];else{if(l[a]!==t)return s=l[a],!1;if(!e.isPlainObject(l[o])||n==r)return l[o]!==t&&(s=l[o],!1);l=l[o]}})),e.isFunction(s)?c=s.apply(o,n):s!==t&&(c=s),e.isArray(a)?a.push(c):a!==t?a=[a,c]:c!==t&&(a=c),s}},g?(N===t&&M.initialize(),M.invoke(f)):(N!==t&&N.invoke("destroy"),M.initialize())}),a!==t?a:this},e.fn.modal.settings={name:"Modal",namespace:"modal",silent:!1,debug:!1,verbose:!1,performance:!0,observeChanges:!1,allowMultiple:!1,detachable:!0,closable:!0,autofocus:!0,inverted:!1,blurring:!1,dimmerSettings:{closable:!1,useCSS:!0},
// whether to use keyboard shortcuts
keyboardShortcuts:!0,context:"body",queue:!1,duration:500,offset:0,transition:"scale",
// padding with edge of page
padding:50,
// called before show animation
onShow:function(){},
// called after show animation
onVisible:function(){},
// called before hide animation
onHide:function(){return!0},
// called after hide animation
onHidden:function(){},
// called after approve selector match
onApprove:function(){return!0},
// called after deny selector match
onDeny:function(){return!0},selector:{close:"> .close",approve:".actions .positive, .actions .approve, .actions .ok",deny:".actions .negative, .actions .deny, .actions .cancel",modal:".ui.modal"},error:{dimmer:"UI Dimmer, a required component is not included in this page",method:"The method you called is not defined.",notFound:"The element you specified could not be found"},className:{active:"active",animating:"animating",blurring:"blurring",inverted:"inverted",loading:"loading",scrolling:"scrolling",undetached:"undetached"}}}(jQuery,window,document);