/**
 * name: CollectionPlayerController.js
 * author: Anuj Gupta
 * Date: 02-11-2017
 */

'use strict'
describe('CollectionPlayerCtrl', function () {
  beforeEach(module('playerApp'))
  beforeEach(inject(function ($rootScope, $controller) {
    $controller('AppCtrl', {
      $rootScope: $rootScope,
      $scope: $rootScope.$new()
    })
  }))
  var rootScope, $stateParams, courseService, $timeout,
    scope, $state, $q, deferred, cpvm
  var collectionPlayerCtrl,
    courseHierarchyResponse = {'id': 'api.course.hierarchy', 'ver': '1.0', 'ts': '2017-09-27T12:59:38.318Z', 'params': {'resmsgid': 'b81f1ee0-a383-11e7-bfbf-79d3eb8b325a', 'msgid': 'b80fb590-a383-11e7-a02d-39375ec54822', 'status': 'successful', 'err': null, 'errmsg': null}, 'responseCode': 'OK', 'result': {'content': {'subject': 'Hindi', 'channel': 'b00bc992ef25f1a9a8d63291e20efc8d', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212345541699534848166/note-test-course_1505885449121_do_212345541699534848166_1.0.ecar', 'language': ['English'], 'variants': {'spine': {'ecarUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212345541699534848166/note-test-course_1505885454297_do_212345541699534848166_1.0_spine.ecar', 'size': 2153340}}, 'mimeType': 'application/vnd.ekstep.content-collection', 'c_null_private_batch_count': 1, 'gradeLevel': ['Grade 1'], 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212345541699534848166/artifact/1q12_330_1467701049_1467701049228.thumb.png', 'collections': [], 'children': [{'copyright': '', 'keywords': ['tes'], 'subject': '', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_20052190/collection-test_1497423235659_do_20052190_1.0.ecar', 'language': ['English', 'Bengali', 'Marathi', 'Hindi'], 'mimeType': 'application/vnd.ekstep.content-collection', 'variants': {'spine': {'ecarUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_20052190/collection-test_1497423243496_do_20052190_1.0_spine.ecar', 'size': 2806812}}, 'source': '', 'gradeLevel': ['Grade 1', 'Grade 2', 'Grade 3', 'Grade 4', 'Grade 5', 'Kindergarten', 'Other'], 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_20052190/artifact/c43943b4c5001b62a64dd63e897d3a61_1475832877688.thumb.jpeg', 'collections': [{'identifier': 'do_2122951960376197121275', 'name': 'Module1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Module1', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212303067590107136184', 'name': 'Chapter 3', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': '12', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123213230609940481796', 'name': 'Plan 2', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Brief description added here', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212345541699534848166', 'name': 'Note test course', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Note test course', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123215089062379521871', 'name': 'to test the batch issue', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test batch', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212296743652950016193', 'name': 'Not in', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'after filters are removed it should automatically load the corresponding pages rather than clicking on apply .', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212198254717476864145', 'name': 'test collection1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test collection1', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212323362542485504184', 'name': 'Physics Book - Grade 6', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Physics Book - Grade 6', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123172316053831681505', 'name': 'J Batch 1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Test content uploaded by Creator user', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123222510609940481113', 'name': 'test the leaf nodes', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123249175889674241410', 'name': 'Test course1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Test course1', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212300292309819392119', 'name': 'Unit One_1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212292806744178688159', 'name': 'Test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': null, 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212292806744178688159', 'name': 'Test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': null, 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123214761370992641862', 'name': 'qazwsxedcrfvtgbhnujmik,ol.p;/', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'ghgh', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212312287059542016160', 'name': 'Testtextbook', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test description', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123171405705707521479', 'name': 'JP Course 1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Test content uploaded by Creator user', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123228847562915841189', 'name': 'gfh', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'fghfgh', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'children': [{'subject': 'English', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212262876810362880123/test-new-lesson-4_1496998836392_do_212262876810362880123_3.0.ecar', 'language': ['English'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'variants': {'spine': {'ecarUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212262876810362880123/test-new-lesson-4_1496998836684_do_212262876810362880123_3.0_spine.ecar', 'size': 257067}}, 'source': '', 'editorState': '{"plugin":{"noOfExtPlugins":0,"extPlugins":[]},"stage":{"noOfStages":3,"currentStage":"383e5ac0-3b26-4850-9594-26e474561a52"},"sidebar":{"selectedMenu":"settings"}}', 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212262876810362880123/artifact/77516c5dbe2f3789c56e3125484e1332_1496905809780.thumb.jpeg', 'gradeLevel': ['Grade 1', 'Grade 2'], 'me_totalTimespent': 169.62, 'me_averageTimespentPerSession': 42.41, 'collections': [{'identifier': 'do_212265470855659520152', 'name': 'sub unit 1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Testing', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2122959942901678081122', 'name': 'Test_1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Testing', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212265730509160448195', 'name': 'QA', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'www', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212326260784889856118', 'name': 'Unit sample book', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'first unit in the book, this is for testing only', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212263417778872320165', 'name': 'nidhi check', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212262952066768896127', 'name': 'QA TEST', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'appId': 'qa.ekstep.in', 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212262876810362880123/artifact/1496933376493_do_212262876810362880123.zip', 'contentType': 'Story', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-09T09:00:37.010+0000', 'identifier': 'do_212262876810362880123', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'index': 22, 'mediaType': 'content', 'ageGroup': ['5-6', '6-7'], 'osId': 'org.ekstep.quiz.app', 'prevState': 'Draft', 'lastPublishedOn': '2017-06-09T09:00:36.392+0000', 'size': 1156210, 'concepts': [{'identifier': 'C7', 'name': 'Sequence', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Compare, order and arrange numbers; mental number line; properties of numbers (odd, even, squares, etc.)', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'C8', 'name': 'Place value', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Vocabulary of place value, understanding ones, tens and higher digit place values, expansion of numbers', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'domain': ['numeracy'], 'me_averageSessionsPerDevice': 2, 'name': 'Test new lesson 4', 'publisher': '', 'attributions': [''], 'status': 'Live', 'template': '', 'me_averageInteractionsPerMin': 0, 'code': 'org.ekstep.numeracy.worksheet.6817', 'me_totalSessionsCount': 4, 'description': 'TEst', 'lastFlaggedOn': '2017-06-09T07:56:30.486+0000', 'medium': 'English', 'flaggedBy': ['Vignesh'], 'posterImage': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212262652393340928136/artifact/77516c5dbe2f3789c56e3125484e1332_1496905809780.jpeg', 'idealScreenSize': 'normal', 'createdOn': '2017-06-09T02:06:19.050+0000', 'popularity': 169.62, 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-06-09T02:06:19.118+0000', 'me_totalDevices': 2, 'owner': 'Vignesh', 'createdFor': [''], 'creator': 'Vignesh Pandi', 'os': ['All'], 'me_totalInteractions': 0, 'pkgVersion': 3, 'versionKey': '1496998837010', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_212262876810362880123/test-new-lesson-4_1496998836392_do_212262876810362880123_3.0.ecar', 'createdBy': '361', 'compatibilityLevel': 2, 'organization': ['']}, {'copyright': '', 'keywords': ['english'], 'subject': 'English', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212198907419213824194/testing-review_1496126423807_do_212198907419213824194_2.0.ecar', 'language': ['English'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'variants': {'spine': {'ecarUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212198907419213824194/testing-review_1496126423992_do_212198907419213824194_2.0_spine.ecar', 'size': 279900}}, 'source': '', 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212198907419213824194/artifact/994d5f247a3f1f73e61b3a3f0d740d03_1495709466010.thumb.jpeg', 'gradeLevel': ['Grade 1', 'Grade 2'], 'collections': [{'identifier': 'do_212262853837021184111', 'name': 'test 11', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'fgddg', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212263441041465344169', 'name': 'Fix flag issue', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Fix flag issue', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212263352407949312155', 'name': 'Test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_21226284833619968019', 'name': 'testing QAA', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'egeeeg', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'appId': 'qa.ekstep.in', 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212198907419213824194/artifact/1496126423688_do_212198907419213824194.zip', 'contentType': 'Story', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-12T05:10:37.655+0000', 'lastUpdatedBy': '386', 'identifier': 'do_212198907419213824194', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '363', 'index': 23, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'ageGroup': ['6-7', '5-6'], 'lastPublishedBy': '386', 'tags': ['english'], 'prevState': 'Review', 'lastPublishedOn': '2017-05-30T06:40:23.807+0000', 'size': 284758, 'concepts': [{'identifier': 'Num:C3:SC1', 'name': 'Addition/subtraction', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Addition/subtraction', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'domain': ['numeracy'], 'name': 'Testing REview', 'publisher': '', 'status': 'Live', 'template': '', 'code': 'org.ekstep.numeracy.story.4935', 'description': 'TEsting review', 'medium': 'English', 'posterImage': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_2122528519453655041246/artifact/994d5f247a3f1f73e61b3a3f0d740d03_1495709466010.jpeg', 'idealScreenSize': 'normal', 'createdOn': '2017-05-30T06:26:44.511+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-05-30T06:40:25.286+0000', 'owner': 'vinod', 'createdFor': ['org.ekstep.partner.vinod303'], 'creator': 'Vinod Kumar S 303', 'os': ['All'], 'pkgVersion': 2, 'versionKey': '1497244237655', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_212198907419213824194/testing-review_1496126423807_do_212198907419213824194_2.0.ecar', 'createdBy': '363', 'compatibilityLevel': 2, 'organization': ['TestVinod30']}, {'copyright': '', 'subject': '', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212255663749021696154/test-new_1496052987504_do_212255663749021696154_3.0.ecar', 'language': ['English'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'variants': {'spine': {'ecarUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212255663749021696154/test-new_1496052987618_do_212255663749021696154_3.0_spine.ecar', 'size': 7275}}, 'source': '', 'gradeLevel': ['Grade 1'], 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_2122549980406497281343/artifact/33bae3819851db91207307e7a03fae9b_1495971440524.jpeg', 'collections': [{'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212265471036104704153', 'name': 'Unit 2', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'asd', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_21226212736207257618', 'name': 'Untitled Lesson', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': '', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_21226542306931507219', 'name': 'Sub UT', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'children': [], 'appId': 'qa.ekstep.in', 'usesContent': [], 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212255663749021696154/artifact/1496052820271_do_212255663749021696154.zip', 'contentType': 'Story', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-09T00:51:11.175+0000', 'item_sets': [], 'lastUpdatedBy': '436', 'identifier': 'do_212255663749021696154', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '239', 'index': 24, 'mediaType': 'content', 'ageGroup': ['<5'], 'osId': 'org.ekstep.quiz.app', 'lastPublishedBy': '436', 'prevState': 'Review', 'lastPublishedOn': '2017-05-29T10:16:27.503+0000', 'size': 7843, 'concepts': [], 'domain': ['literacy'], 'name': 'test new', 'publisher': '', 'status': 'Live', 'template': '', 'code': 'org.ekstep.literacy.story.6500', 'methods': [], 'description': 'testtesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttestte\r\n\r\n\r\n\r\n\r\n\r\nsttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttest', 'medium': '', 'idealScreenSize': 'normal', 'createdOn': '2017-05-29T10:15:54.658+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-06-05T05:08:40.264+0000', 'owner': 'test', 'createdFor': [''], 'creator': 'External Testing vendor', 'os': ['All'], 'libraries': [], 'pkgVersion': 3, 'versionKey': '1496969471175', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_212255663749021696154/test-new_1496052987504_do_212255663749021696154_3.0.ecar', 'createdBy': '239', 'compatibilityLevel': 2, 'organization': ['']}, {'copyright': '', 'subject': 'MATHS', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_2122431925929410561177/division_1494563392724_do_2122431925929410561177_1.0.ecar', 'language': ['Hindi'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'variants': {'spine': {'ecarUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_2122431925929410561177/division_1494563392841_do_2122431925929410561177_1.0_spine.ecar', 'size': 63909}}, 'source': '', 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_2122431925929410561177/artifact/1754294cb1cf076977bf631d0d049dca_1493790022988.thumb.jpeg', 'gradeLevel': ['Grade 4', 'Grade 5'], 'collections': [{'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212265458014896128139', 'name': 'QA Test - Collection form - 12 June 2017', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'QA Test - Collection form - 12 June 2017\r\nQA Test - Collection form - 12 June 2017', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212262885237284864125', 'name': 'QA 1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'fhfhf', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123208118704128001782', 'name': 'CourseTest3', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': null, 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_21226284157083648018', 'name': 'colors on QA', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'gdgdg', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212288967830339584150', 'name': 'Unit 3.1.1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Unit 3.1.1', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212282811941707776187', 'name': 'Unit 2.2', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Unit 2.2', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'children': [], 'appId': 'qa.ekstep.in', 'usesContent': [], 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_2122431925929410561177/artifact/1494563392408_do_2122431925929410561177.zip', 'contentType': 'Story', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-12T07:16:56.852+0000', 'item_sets': [], 'lastUpdatedBy': '582', 'identifier': 'do_2122431925929410561177', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '705', 'index': 25, 'mediaType': 'content', 'ageGroup': ['6-7', '7-8', '>10', '8-10', '5-6'], 'osId': 'org.ekstep.quiz.app', 'lastPublishedBy': '582', 'prevState': 'Review', 'lastPublishedOn': '2017-05-12T04:29:52.724+0000', 'size': 149082, 'concepts': [], 'domain': ['numeracy'], 'name': 'Division', 'publisher': '', 'status': 'Live', 'template': '', 'code': 'org.ekstep.numeracy.story.6214', 'methods': [], 'description': 'Division for children', 'medium': 'Hindi', 'posterImage': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212237127868194816117/artifact/1754294cb1cf076977bf631d0d049dca_1493790022988.jpeg', 'idealScreenSize': 'normal', 'createdOn': '2017-05-11T19:19:05.817+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-06-05T04:31:10.018+0000', 'owner': 'Debesh', 'createdFor': [''], 'creator': 'Debesh Rout', 'os': ['All'], 'libraries': [], 'pkgVersion': 1, 'versionKey': '1497251816852', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_2122431925929410561177/division_1494563392724_do_2122431925929410561177_1.0.ecar', 'createdBy': '705', 'compatibilityLevel': 1, 'organization': ['']}, {'copyright': '', 'subject': 'English', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212240858223681536146/test_1494250356884_do_212240858223681536146_1.0.ecar', 'language': ['English'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'variants': {'spine': {'ecarUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212240858223681536146/test_1494250357003_do_212240858223681536146_1.0_spine.ecar', 'size': 41008}}, 'source': '', 'gradeLevel': ['Kindergarten'], 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212240858223681536146/artifact/163202d4427706dc03018521cb804230_1492173473339.thumb.jpeg', 'collections': [{'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'children': [], 'appId': 'qa.ekstep.in', 'usesContent': [], 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212240858223681536146/artifact/1494250356549_do_212240858223681536146.zip', 'contentType': 'Story', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-09T00:41:49.264+0000', 'item_sets': [], 'lastUpdatedBy': '349', 'identifier': 'do_212240858223681536146', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '225', 'index': 26, 'mediaType': 'content', 'ageGroup': ['<5'], 'osId': 'org.ekstep.quiz.app', 'lastPublishedBy': '349', 'prevState': 'Review', 'lastPublishedOn': '2017-05-08T13:32:36.884+0000', 'size': 45646, 'concepts': [], 'domain': ['literacy'], 'name': 'test', 'publisher': '', 'status': 'Live', 'template': '', 'code': 'org.ekstep.literacy.story.6111', 'methods': [], 'description': 'Test', 'medium': 'English', 'posterImage': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_2122238850934784001351/artifact/163202d4427706dc03018521cb804230_1492173473339.jpeg', 'idealScreenSize': 'normal', 'createdOn': '2017-05-08T12:09:48.633+0000', 'screenshots': ['https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212237870282612736139/artifact/7c7693e6e67b0ad098428532fe4a8299_1493880649749.jpeg'], 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-06-04T04:19:06.869+0000', 'owner': 'Test', 'createdFor': [''], 'creator': 'Gourav More', 'os': ['All'], 'libraries': [], 'pkgVersion': 1, 'versionKey': '1496968909264', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_212240858223681536146/test_1494250356884_do_212240858223681536146_1.0.ecar', 'createdBy': '225', 'compatibilityLevel': 1, 'organization': ['']}, {'copyright': '', 'subject': 'English', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212240809303359488137/test-download_1494240217435_do_212240809303359488137_1.0.ecar', 'language': ['English'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'variants': {'spine': {'ecarUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212240809303359488137/test-download_1494240217584_do_212240809303359488137_1.0_spine.ecar', 'size': 5795}}, 'source': '', 'gradeLevel': ['Kindergarten'], 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212227254885023744156/artifact/a91d4a6f02f8b2cd4d6885d3ec7bc468_1492584824847.jpeg', 'collections': [{'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212288967830339584150', 'name': 'Unit 3.1.1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Unit 3.1.1', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'children': [], 'appId': 'qa.ekstep.in', 'usesContent': [], 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212240809303359488137/artifact/1494240173246_do_212240809303359488137.zip', 'contentType': 'Story', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-09T00:41:47.696+0000', 'item_sets': [], 'lastUpdatedBy': '349', 'identifier': 'do_212240809303359488137', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '225', 'index': 27, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'ageGroup': ['<5'], 'lastPublishedBy': '349', 'prevState': 'Review', 'lastPublishedOn': '2017-05-08T10:43:37.434+0000', 'size': 25958, 'concepts': [], 'domain': ['literacy'], 'name': 'Test Download', 'publisher': '', 'status': 'Live', 'template': '', 'code': 'org.ekstep.literacy.story.6093', 'methods': [], 'description': 'Test Download description', 'medium': 'English', 'idealScreenSize': 'normal', 'createdOn': '2017-05-08T10:30:16.914+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-05-15T07:14:33.447+0000', 'owner': 'Test', 'createdFor': [''], 'creator': 'Gourav More', 'os': ['All'], 'libraries': [], 'pkgVersion': 1, 'versionKey': '1496968907696', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_212240809303359488137/test-download_1494240217435_do_212240809303359488137_1.0.ecar', 'createdBy': '225', 'compatibilityLevel': 1, 'organization': ['']}, {'copyright': '', 'subject': '', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212240782217428992134/comp_1494236677935_do_212240782217428992134_2.0.ecar', 'language': ['Bengali'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'variants': {'spine': {'ecarUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212240782217428992134/comp_1494236678042_do_212240782217428992134_2.0_spine.ecar', 'size': 63932}}, 'source': '', 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212240782217428992134/artifact/1754294cb1cf076977bf631d0d049dca_1493790022988.thumb.jpeg', 'collections': [{'identifier': 'do_212292464202481664133', 'name': 'Copied from Collection Sequence', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection Sequence', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212265458014896128139', 'name': 'QA Test - Collection form - 12 June 2017', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'QA Test - Collection form - 12 June 2017\r\nQA Test - Collection form - 12 June 2017', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212277571964256256160', 'name': 'Collection Sequence', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection Sequence', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'appId': 'qa.ekstep.in', 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212240782217428992134/artifact/1494236513433_do_212240782217428992134.zip', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-12T07:16:56.302+0000', 'contentType': 'Story', 'identifier': 'do_212240782217428992134', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '332', 'index': 28, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'prevState': 'Draft', 'lastPublishedOn': '2017-05-08T09:44:37.935+0000', 'size': 65582, 'concepts': [{'identifier': 'LO7', 'name': 'Decoding for Reading', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Decoding for Reading', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'domain': ['literacy'], 'name': 'Comp', 'publisher': '', 'status': 'Live', 'template': '', 'code': 'org.ekstep.literacy.story.6090', 'description': '', 'medium': '', 'posterImage': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212237127868194816117/artifact/1754294cb1cf076977bf631d0d049dca_1493790022988.jpeg', 'idealScreenSize': 'normal', 'createdOn': '2017-05-08T09:44:13.321+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-05-25T06:40:00.050+0000', 'owner': '', 'createdFor': [''], 'creator': 'Manjunath Davanam', 'os': ['All'], 'pkgVersion': 2, 'versionKey': '1497251816302', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_212240782217428992134/comp_1494236677935_do_212240782217428992134_2.0.ecar', 'createdBy': '332', 'compatibilityLevel': 1, 'organization': ['']}, {'copyright': '', 'subject': '', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212240697884393472122/test-upload_1494238312224_do_212240697884393472122_1.0.ecar', 'language': ['English'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'variants': {'spine': {'ecarUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212240697884393472122/test-upload_1494238312327_do_212240697884393472122_1.0_spine.ecar', 'size': 63868}}, 'source': '', 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212240697884393472122/artifact/1754294cb1cf076977bf631d0d049dca_1493790022988.thumb.jpeg', 'collections': [{'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'appId': 'qa.ekstep.in', 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212240697884393472122/artifact/archive_1494238302413.zip', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-12T05:33:35.860+0000', 'contentType': 'Story', 'identifier': 'do_212240697884393472122', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '405', 'index': 29, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'prevState': 'Draft', 'lastPublishedOn': '2017-05-08T10:11:52.224+0000', 'size': 81923, 'concepts': [{'identifier': 'LO39', 'name': 'Akshara Recognition', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Akshara Recognition', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'domain': ['literacy'], 'name': 'Test Upload', 'publisher': '', 'status': 'Live', 'template': '', 'code': 'org.ekstep.literacy.story.6079', 'description': 'Test upload', 'medium': '', 'posterImage': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212237127868194816117/artifact/1754294cb1cf076977bf631d0d049dca_1493790022988.jpeg', 'idealScreenSize': 'normal', 'createdOn': '2017-05-08T06:43:35.966+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-05-25T06:40:01.472+0000', 'owner': '', 'createdFor': [''], 'creator': 'Kartheek Palla', 'os': ['All'], 'pkgVersion': 1, 'versionKey': '1497245615860', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_212240697884393472122/test-upload_1494238312224_do_212240697884393472122_1.0.ecar', 'createdBy': '405', 'compatibilityLevel': 1, 'organization': ['']}, {'copyright': '', 'keywords': ['MAA'], 'subject': 'Marathi', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212226603638333440142/onion_1492515345651_do_212226603638333440142_1.0.ecar', 'language': ['Marathi'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'variants': {'spine': {'ecarUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212226603638333440142/onion_1492515345750_do_212226603638333440142_1.0_spine.ecar', 'size': 40991}}, 'source': '', 'gradeLevel': ['Grade 2'], 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212226603638333440142/artifact/8be7b91777540f6eeb3be1b755f926d1_1492072982944.thumb.jpeg', 'collections': [{'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123100712899297281137', 'name': 'KTextbook1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'This is about textbooks', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'children': [], 'appId': 'qa.ekstep.in', 'usesContent': [], 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212226603638333440142/artifact/1492515345439_do_212226603638333440142.zip', 'contentType': 'Story', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-12T05:41:18.077+0000', 'item_sets': [], 'lastUpdatedBy': '129', 'identifier': 'do_212226603638333440142', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '671', 'index': 30, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'ageGroup': ['5-6'], 'lastPublishedBy': '129', 'tags': ['MAA'], 'prevState': 'Review', 'size': 65857, 'lastPublishedOn': '2017-04-18T11:35:45.651+0000', 'concepts': [], 'domain': ['numeracy'], 'name': 'Onion', 'publisher': '', 'status': 'Live', 'template': '', 'code': 'org.ekstep.numeracy.story.5787', 'methods': [], 'description': 'this is a story', 'medium': 'Marathi', 'posterImage': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_2122230618761543681326/artifact/8be7b91777540f6eeb3be1b755f926d1_1492072982944.jpeg', 'idealScreenSize': 'normal', 'createdOn': '2017-04-18T08:48:46.945+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-06-05T04:45:08.832+0000', 'owner': 'Abhinav', 'creator': 'Abhinav Unni', 'os': ['All'], 'libraries': [], 'pkgVersion': 1, 'versionKey': '1497246078077', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_212226603638333440142/onion_1492515345651_do_212226603638333440142_1.0.ecar', 'createdBy': '671', 'compatibilityLevel': 1}, {'copyright': '', 'subject': 'Hindi', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212226541663813632135/credit-check_1492498695660_do_212226541663813632135_1.0.ecar', 'language': ['Bengali'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'variants': {'spine': {'ecarUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212226541663813632135/credit-check_1492498695924_do_212226541663813632135_1.0_spine.ecar', 'size': 348930}}, 'source': '', 'gradeLevel': ['Grade 1'], 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212226541663813632135/artifact/dc78700d06fbeadd48fcc93b714755ac_1491497453756.thumb.jpeg', 'collections': [{'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'appId': 'ekstep_portal', 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212226541663813632135/artifact/1492498695107_do_212226541663813632135.zip', 'contentType': 'Story', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-12T07:16:56.585+0000', 'lastUpdatedBy': '273', 'identifier': 'do_212226541663813632135', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '325', 'index': 31, 'mediaType': 'content', 'ageGroup': ['5-6'], 'osId': 'org.ekstep.quiz.app', 'lastPublishedBy': '273', 'prevState': 'Review', 'size': 384962, 'lastPublishedOn': '2017-04-18T06:58:15.660+0000', 'concepts': [{'identifier': 'LO37', 'name': 'Tracing Akshara', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Tracing Akshara', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'domain': ['literacy'], 'name': 'Credit check', 'publisher': '', 'status': 'Retired', 'template': '', 'code': 'org.ekstep.literacy.story.5784', 'description': 'Credit check', 'medium': 'Bengali', 'idealScreenSize': 'normal', 'posterImage': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_2122183471410135041134/artifact/dc78700d06fbeadd48fcc93b714755ac_1491497453756.jpeg', 'createdOn': '2017-04-18T06:42:41.696+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-08-16T12:55:42.297+0000', 'owner': 'umesh', 'creator': 'Umesh Thorat', 'os': ['All'], 'pkgVersion': 1, 'versionKey': '1502888142297', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_212226541663813632135/credit-check_1492498695660_do_212226541663813632135_1.0.ecar', 'createdBy': '325', 'compatibilityLevel': 1}, {'copyright': '', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212155138116665344268/regression-test_1484197939550_do_212155138116665344268_1.0.ecar', 'language': ['English'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'source': '', 'editorState': 'undefined', 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212155138116665344268/artifact/26674093ca930c5fb08324f5b6963a87_1478510250978.thumb.jpeg', 'gradeLevel': ['Grade 1'], 'collections': [{'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'appId': 'qa.ekstep.in', 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212155138116665344268/artifact/1484197938774_do_212155138116665344268.zip', 'contentType': 'Story', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-12T05:37:56.258+0000', 'lastUpdatedBy': '436', 'identifier': 'do_212155138116665344268', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '239', 'index': 32, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'ageGroup': ['5-6'], 'lastPublishedBy': '436', 'size': 4700612, 'lastPublishedOn': '2017-01-12T05:12:20.217+0000', 'concepts': [{'identifier': 'LO14', 'name': 'Syllable Awareness', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Syllable Awareness', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'LO16', 'name': 'Onset-Coda Awareness', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Onset-Coda Awareness', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'domain': ['literacy'], 'name': 'regression test', 'publisher': '', 'status': 'Live', 'template': 'do_20043409', 'code': 'org.ekstep.literacy.story.3620', 'imageCredits': ['Sumangala GM'], 'description': 'test', 'posterImage': 'https://qa.ekstep.in/assets/public/content/do_20052047/artifact/26674093ca930c5fb08324f5b6963a87_1478510250978.jpeg', 'idealScreenSize': 'normal', 'createdOn': '2017-01-07T09:31:48.381+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-05-15T07:10:32.743+0000', 'owner': 'External Testing vendor', 'creator': 'External Testing vendor', 'os': ['All'], 'soundCredits': ['2'], 'pkgVersion': 1, 'versionKey': '1497245876258', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_212155138116665344268/regression-test_1484197939550_do_212155138116665344268_1.0.ecar', 'lastSubmittedOn': '2017-01-07T09:33:14.921+0000', 'createdBy': '239', 'compatibilityLevel': 1}, {'copyright': '', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212166457175425024135/recordplay_v2_1485164348714_do_212166457175425024135_1.0.ecar', 'language': ['English'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'source': '', 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212166457175425024135/artifact/773d7b15183eb90dd4ec5d084672a62d_1485146075011.thumb.jpeg', 'gradeLevel': ['Grade 1'], 'collections': [{'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'children': [], 'appId': 'qa.ekstep.in', 'usesContent': [], 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212166457175425024135/artifact/1485164348144_do_212166457175425024135.zip', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-12T05:31:12.507+0000', 'contentType': 'Story', 'item_sets': [], 'lastUpdatedBy': '434', 'identifier': 'do_212166457175425024135', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '239', 'index': 33, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'ageGroup': ['5-6'], 'lastPublishedBy': '434', 'size': 2194992, 'lastPublishedOn': '2017-01-23T09:39:09.088+0000', 'concepts': [], 'domain': ['literacy'], 'name': 'Record&Play_V2', 'publisher': '', 'status': 'Live', 'template': '', 'code': 'org.ekstep.literacy.story.4106', 'methods': [], 'description': 'test', 'posterImage': 'https://qa.ekstep.in/assets/public/content/do_212166316646170624221/artifact/773d7b15183eb90dd4ec5d084672a62d_1485146075011.jpeg', 'idealScreenSize': 'normal', 'createdOn': '2017-01-23T09:20:29.422+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-05-15T07:11:11.412+0000', 'owner': 'External Testing vendor', 'creator': 'External Testing vendor', 'os': ['All'], 'libraries': [], 'pkgVersion': 1, 'versionKey': '1497245472507', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_212166457175425024135/recordplay_v2_1485164348714_do_212166457175425024135_1.0.ecar', 'lastSubmittedOn': '2017-01-23T09:38:47.335+0000', 'createdBy': '239', 'compatibilityLevel': 1}, {'copyright': 'TestCopyright', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_20052801/test81.22016-06_1481279401751_do_20052801_2.0.ecar', 'language': ['Hindi'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'source': 'TestSource', 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_20052801/artifact/6755f184977a2d60daac4b17734b064f_1476686916929.thumb.jpeg', 'gradeLevel': ['Grade 1', 'Grade 2'], 'collections': [{'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'children': [], 'appId': 'qa.ekstep.in', 'usesContent': [], 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_20052801/artifact/1481279128035_do_20052801.zip', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-12T05:26:06.697+0000', 'contentType': 'Story', 'item_sets': [], 'lastUpdatedBy': '239', 'identifier': 'do_20052801', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '239', 'index': 34, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'ageGroup': ['5-6', '7-8'], 'lastPublishedOn': '2016-12-09T10:30:02.312+0000', 'size': 2324265, 'concepts': [], 'domain': ['literacy'], 'name': 'Test81.22016-06#', 'publisher': 'TestPublisher', 'status': 'Live', 'template': 'do_20044108', 'code': 'org.ekstep.literacy.story.3417', 'methods': [], 'imageCredits': ['TestSQS'], 'description': 'Test', 'posterImage': 'https://qa.ekstep.in/assets/public/content/6755f184977a2d60daac4b17734b064f_1476686916929.jpeg', 'idealScreenSize': 'normal', 'createdOn': '2016-12-08T11:36:25.171+0000', 'contentDisposition': 'inline', 'genre': ['Picture Books', 'Chapter Books'], 'lastUpdatedOn': '2017-05-15T07:09:39.347+0000', 'theme': ['Art', 'Funny'], 'owner': 'External Testing vendor', 'creator': 'External Testing vendor', 'os': ['All'], 'libraries': [], 'pkgVersion': 2, 'versionKey': '1497245166697', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_20052801/test81.22016-06_1481279401751_do_20052801_2.0.ecar', 'lastSubmittedOn': '2016-12-09T10:29:44.794+0000', 'createdBy': '239', 'compatibilityLevel': 1}, {'copyright': '', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_20052449/divisiontest_1480337510466_do_20052449_1.0.ecar', 'language': ['English'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'source': '', 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_20052449/artifact/4f5155a71330beebf030fb488c51fd79_1476686866253.thumb.jpeg', 'gradeLevel': ['Grade 1'], 'me_totalTimespent': 152.38, 'me_averageTimespentPerSession': 30.48, 'collections': [{'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'appId': 'qa.ekstep.in', 'me_totalRatings': 0, 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_20052449/artifact/archive_200_1480337161_1480337446451.zip', 'contentType': 'Story', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-12T05:24:44.066+0000', 'lastUpdatedBy': '200', 'identifier': 'do_20052449', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '200', 'index': 35, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'ageGroup': ['5-6'], 'lastPublishedOn': '2016-11-28T12:51:51.890+0000', 'size': 427126, 'concepts': [{'identifier': 'LO52', 'name': 'More Than One Meaning', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'More Than One Meaning', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'domain': ['literacy'], 'me_averageSessionsPerDevice': 2.5, 'name': 'DivisionTest', 'publisher': '', 'status': 'Live', 'template': 'do_20043409', 'me_averageInteractionsPerMin': 14.57, 'code': 'org.ekstep.literacy.story.3080', 'me_totalSessionsCount': 5, 'description': 'div test', 'idealScreenSize': 'normal', 'posterImage': 'https://qa.ekstep.in/assets/public/content/4f5155a71330beebf030fb488c51fd79_1476686866253.jpeg', 'createdOn': '2016-11-28T12:50:12.731+0000', 'me_totalSideloads': 0, 'me_totalComments': 0, 'popularity': 152.38, 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-05-15T07:09:17.487+0000', 'me_totalDevices': 2, 'me_totalDownloads': 6, 'owner': 'Srivathsa Dhanraj', 'creator': 'Srivathsa Dhanraj', 'os': ['All'], 'me_totalInteractions': 37, 'pkgVersion': 1, 'versionKey': '1497245084066', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_20052449/divisiontest_1480337510466_do_20052449_1.0.ecar', 'me_averageRating': 0, 'createdBy': '200', 'compatibilityLevel': 1}, {'copyright': '', 'channel': '505c7c48ac6dc1edc9b08f21db5a571d', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212155118871101440166/b_1483782013636_do_212155118871101440166_1.0.ecar', 'language': ['English'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'source': '', 'gradeLevel': ['Grade 1'], 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212155118871101440166/artifact/apple_239_1483680875_1483680875225.thumb.jpg', 'me_totalTimespent': 12.61, 'me_averageTimespentPerSession': 6.31, 'collections': [{'identifier': 'do_2123242743311155201348', 'name': 'Chetan\'s course unit', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Chetan\'s course unit description', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_21232299526136627211056', 'name': 'Untitled collection', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'some description', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123250226715688961520', 'name': 'TestCourse', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Test Course Description', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123250892046663681618', 'name': 'Test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Book', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123250158331985921500', 'name': 'dash1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'fsdff', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123278324571914241310', 'name': 'Sep Course Unit', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Sep Course Unit Description', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123228935551959041197', 'name': 'BatchJp Course', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'appId': 'sunbird.portal', 'me_totalRatings': 0, 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212155118871101440166/artifact/1483779374020_do_212155118871101440166.zip', 'contentType': 'Story', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-12T05:18:21.039+0000', 'lastUpdatedBy': 'Public User', 'identifier': 'do_212155118871101440166', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '361', 'index': 36, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'ageGroup': ['5-6'], 'lastPublishedBy': '399', 'lastPublishedOn': '2017-01-07T09:40:13.835+0000', 'size': 37892, 'concepts': [{'identifier': 'LO53', 'name': 'Word Context', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Accurate Word For Context', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'domain': ['literacy'], 'me_averageSessionsPerDevice': 1, 'name': 'b', 'publisher': '', 'status': 'Live', 'template': '', 'me_averageInteractionsPerMin': 52.34, 'code': 'org.ekstep.literacy.story.1838', 'me_totalSessionsCount': 2, 'description': 'b', 'lastFlaggedOn': '2017-08-30T11:15:37.227+0000', 'flaggedBy': ['Public User'], 'posterImage': 'https://qa.ekstep.in/assets/public/content/do_212154313729384448213/artifact/apple_239_1483680875_1483680875225.jpg', 'idealScreenSize': 'normal', 'createdOn': '2017-01-07T08:52:39.070+0000', 'me_totalSideloads': 2, 'me_totalComments': 0, 'popularity': 12.61, 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-08-31T12:21:03.596+0000', 'me_totalDevices': 2, 'me_totalDownloads': 55, 'owner': 'sqs ek', 'creator': 'Vignesh Pandi', 'os': ['All'], 'me_totalInteractions': 11, 'pkgVersion': 1, 'versionKey': '1504182063596', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_212155118871101440166/b_1483782013636_do_212155118871101440166_1.0.ecar', 'me_averageRating': 0, 'lastSubmittedOn': '2017-01-07T09:30:03.150+0000', 'createdBy': '361', 'compatibilityLevel': 1}, {'copyright': '', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212153796255105024178/test_1484126411309_do_212153796255105024178_1.0.ecar', 'language': ['English'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'source': '', 'gradeLevel': ['Grade 1'], 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212153796255105024178/artifact/ff80b6a190d1deec2e13f890fe954a61_1483610542462.thumb.jpeg', 'collections': [{'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'appId': 'qa.ekstep.in', 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212153796255105024178/artifact/1484126410843_do_212153796255105024178.zip', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-12T05:30:21.991+0000', 'contentType': 'Story', 'lastUpdatedBy': '86', 'identifier': 'do_212153796255105024178', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '309', 'index': 37, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'ageGroup': ['5-6'], 'lastPublishedBy': '86', 'size': 539000, 'lastPublishedOn': '2017-01-11T09:20:11.560+0000', 'concepts': [{'identifier': 'LO45', 'name': 'Comprehension Of Essays', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Comprehension Of Essays', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'domain': ['literacy'], 'name': 'Test', 'publisher': '', 'status': 'Live', 'template': '', 'code': 'org.ekstep.literacy.story.1794', 'description': 'Test', 'posterImage': 'https://qa.ekstep.in/assets/public/content/do_212153737563324416165/artifact/ff80b6a190d1deec2e13f890fe954a61_1483610542462.jpeg', 'idealScreenSize': 'normal', 'createdOn': '2017-01-05T12:01:46.922+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-05-15T07:10:24.150+0000', 'owner': 'Amol Ghatol', 'creator': 'Rohan Baruah', 'os': ['All'], 'pkgVersion': 1, 'versionKey': '1497245421991', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_212153796255105024178/test_1484126411309_do_212153796255105024178_1.0.ecar', 'lastSubmittedOn': '2017-01-06T07:19:14.235+0000', 'createdBy': '309', 'compatibilityLevel': 1}, {'copyright': '', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_20052437/test28112016-01_1480326779696_do_20052437_1.0.ecar', 'language': ['English'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'source': '', 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_20052437/artifact/cd6a3879896b0e6c73af4d1164f97572_1475658217916.thumb.jpeg', 'gradeLevel': ['Grade 1'], 'collections': [{'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'appId': 'qa.ekstep.in', 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_20052437/artifact/1478667750410_do_20052197_239_1480324923_1480325208089.zip', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-12T05:30:20.522+0000', 'contentType': 'Story', 'lastUpdatedBy': '239', 'identifier': 'do_20052437', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '239', 'index': 38, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'ageGroup': ['5-6'], 'lastPublishedOn': '2016-11-28T09:53:00.990+0000', 'size': 8157844, 'concepts': [{'identifier': 'LO45', 'name': 'Comprehension Of Essays', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Comprehension Of Essays', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'domain': ['literacy'], 'name': 'Test28112016-01', 'publisher': '', 'status': 'Live', 'template': 'do_20044108', 'code': 'org.ekstep.literacy.story.3074', 'imageCredits': ['105', 'Sumangala GM'], 'description': 'Test', 'idealScreenSize': 'normal', 'posterImage': 'https://qa.ekstep.in/assets/public/content/cd6a3879896b0e6c73af4d1164f97572_1475658217916.jpeg', 'createdOn': '2016-11-28T09:24:26.240+0000', 'contentDisposition': 'inline', 'genre': ['Picture Books'], 'lastUpdatedOn': '2017-05-15T07:09:19.740+0000', 'theme': ['Art', 'Geography'], 'owner': 'External Testing vendor', 'creator': 'External Testing vendor', 'os': ['All'], 'pkgVersion': 1, 'versionKey': '1497245420522', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_20052437/test28112016-01_1480326779696_do_20052437_1.0.ecar', 'createdBy': '239', 'compatibilityLevel': 1}, {'copyright': '', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212166529687740416143/recordplay_04_1485172233120_do_212166529687740416143_1.0.ecar', 'language': ['English'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'source': '', 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212166508941271040139/artifact/300f7ecab695cc31f154ac66aaa367e1_1484904982521.thumb.jpeg', 'gradeLevel': ['Grade 1'], 'collections': [{'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'appId': 'qa.ekstep.in', 'copyType': 'Enhance', 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212166529687740416143/artifact/1485172232689_do_212166529687740416143.zip', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-12T05:25:24.886+0000', 'contentType': 'Story', 'lastUpdatedBy': '434', 'identifier': 'do_212166529687740416143', 'audience': 'Learner', 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '239', 'index': 39, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'ageGroup': ['5-6'], 'lastPublishedBy': '434', 'languageCode': 'en', 'size': 2264082, 'lastPublishedOn': '2017-01-23T11:50:33.486+0000', 'concepts': [{'identifier': 'LO52', 'name': 'More Than One Meaning', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'More Than One Meaning', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'domain': ['literacy'], 'name': 'Record&Play_04', 'publisher': '', 'status': 'Live', 'template': '', 'code': 'org.ekstep.literacy.story.4109.fork', 'origin': 'do_212166508941271040139', 'description': 'Test', 'idealScreenSize': 'normal', 'createdOn': '2017-01-23T11:48:01.022+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-05-15T07:11:12.812+0000', 'owner': 'External Testing vendor', 'creator': 'External Testing vendor', 'os': ['All'], 'pkgVersion': 1, 'versionKey': '1497245124886', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_212166529687740416143/recordplay_04_1485172233120_do_212166529687740416143_1.0.ecar', 'lastSubmittedOn': '2017-01-23T11:50:05.559+0000', 'createdBy': '239', 'compatibilityLevel': 1}, {'template': 'do_20043409', 'copyright': '', 'code': 'org.ekstep.literacy.story.3518', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_20053728/test-imgg_1482315240657_do_20053728_1.0.ecar', 'description': 'test', 'language': ['Bengali'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'source': '', 'posterImage': 'https://qa.ekstep.in/assets/public/content/do_20053729/artifact/9267bf69c6171d445def1835a1a9f653_1482314510349.jpeg', 'idealScreenSize': 'normal', 'createdOn': '2016-12-21T10:01:14.771+0000', 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_20053728/artifact/9267bf69c6171d445def1835a1a9f653_1482314510349.thumb.jpeg', 'gradeLevel': ['Grade 1'], 'collections': [{'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'appId': 'qa.ekstep.in', 'contentDisposition': 'inline', 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_20053728/artifact/1482315239564_do_20053728.zip', 'lastUpdatedOn': '2017-05-15T07:09:59.866+0000', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-12T05:19:37.450+0000', 'contentType': 'Story', 'item_sets': [{'identifier': 'do_20053732', 'name': 'My Question Set', 'objectType': 'ItemSet', 'relation': 'associatedTo', 'description': null, 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'owner': 'ekstep2 sqs', 'identifier': 'do_20053728', 'audience': ['Learner'], 'creator': 'ekstep2 sqs', 'os': ['All'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '436', 'index': 40, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'ageGroup': ['5-6'], 'pkgVersion': 1, 'versionKey': '1497244777450', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_20053728/test-imgg_1482315240657_do_20053728_1.0.ecar', 'lastSubmittedOn': '2016-12-21T10:13:18.546+0000', 'lastPublishedOn': '2016-12-21T10:14:00.865+0000', 'size': 219731, 'concepts': [{'identifier': 'Num:C3:SC1', 'name': 'Addition/subtraction', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Addition/subtraction', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'LO52', 'name': 'More Than One Meaning', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'More Than One Meaning', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'createdBy': '436', 'compatibilityLevel': 1, 'domain': ['literacy'], 'name': 'test imgg', 'status': 'Live'}, {'copyright': '', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_20052398/test-maha-video_1479891490158_do_20052398_1.0.ecar', 'language': ['Marathi'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'source': '', 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_20052398/artifact/0288d78758c4463dd40892d5a460edf4_1478578597914.thumb.jpeg', 'gradeLevel': ['Grade 1'], 'me_totalTimespent': 24.89, 'me_averageTimespentPerSession': 24.89, 'collections': [{'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'appId': 'qa.ekstep.in', 'me_totalRatings': 1, 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_20052398/artifact/video_do_30100908_128_1479891165_1479891440329.zip', 'contentType': 'Story', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-12T05:24:43.272+0000', 'lastUpdatedBy': '128', 'identifier': 'do_20052398', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '128', 'index': 41, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'ageGroup': ['5-6'], 'lastPublishedOn': '2016-11-23T08:58:12.894+0000', 'size': 17891862, 'concepts': [{'identifier': 'LO52', 'name': 'More Than One Meaning', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'More Than One Meaning', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'domain': ['literacy'], 'me_averageSessionsPerDevice': 1, 'name': 'Test Maha Video', 'publisher': '', 'status': 'Live', 'template': 'do_20043409', 'me_averageInteractionsPerMin': 38.57, 'code': 'org.ekstep.literacy.story.3052', 'me_totalSessionsCount': 1, 'description': 'Test Maha Video', 'posterImage': 'https://qa.ekstep.in/assets/public/content/do_20052111/artifact/0288d78758c4463dd40892d5a460edf4_1478578597914.jpeg', 'idealScreenSize': 'normal', 'createdOn': '2016-11-23T08:55:03.467+0000', 'me_totalSideloads': 0, 'me_totalComments': 0, 'popularity': 24.89, 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-05-15T07:09:15.338+0000', 'me_totalDevices': 1, 'me_totalDownloads': 14, 'owner': 'Feroz Sheikh', 'creator': 'Feroz Sheikh', 'os': ['All'], 'me_totalInteractions': 16, 'pkgVersion': 1, 'versionKey': '1497245083272', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_20052398/test-maha-video_1479891490158_do_20052398_1.0.ecar', 'me_averageRating': 5, 'createdBy': '128', 'compatibilityLevel': 1}, {'copyright': '', 'keywords': ['Camp - 2 (Advance)', 'Story - 3', 'ched', 'Camal Story #14', 'pratham camal stories', 'boat', 'record and play', 'story', 'para level', 'record', 'story and para level', 'hindi stories', 'hindi', 'story level', 'chedh', 'pratham', 'camal stories', 'pratham camal', '140 - 160 words'], 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/domain_4127_1467121049922.ecar', 'voiceCredits': ['EkStep'], 'language': ['Hindi'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'source': 'Pratham', 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/language_assets/slide22_1463742562028.png', 'gradeLevel': ['Kindergarten', 'Grade 1', 'Grade 2', 'Grade 3', 'Grade 4', 'Grade 5', 'Other'], 'me_totalTimespent': 10706.04, 'me_averageTimespentPerSession': 157.44, 'collections': [{'identifier': 'do_2123237237412249601272', 'name': 'KCourse2 - Sep2', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Desription', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212282810555342848180', 'name': 'Test Course 3', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Test Course 3', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123163977504849921367', 'name': 'Story Collection', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'This is collection of stories', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2122881050396508161323', 'name': 'youtube new', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'youtube new', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212282810437918720179', 'name': 'Test Course 2', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Test Course 2', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'children': [], 'appId': 'qa.ekstep.in', 'usesContent': [], 'copyType': 'Enhance', 'me_totalRatings': 12, 'contentEncoding': 'gzip', 'collaborators': ['323', '330', '350', '286'], 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/1467121042064_domain_4127.zip', 'contentType': 'Story', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-05T07:19:10.471+0000', 'item_sets': [], 'lastUpdatedBy': '141', 'identifier': 'domain_4127', 'audience': 'Learner', 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'author': 'Pratham', 'portalOwner': '366', 'index': 42, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'ageGroup': ['<5', '5-6', '6-7', '7-8', '8-10'], 'tags': ['Camp - 2 (Advance)', 'Story - 3', 'ched', 'Camal Story #14', 'pratham camal stories', 'boat', 'record and play', 'story', 'para level', 'record', 'story and para level', 'hindi stories', 'hindi', 'story level', 'chedh', 'pratham', 'camal stories', 'pratham camal', '140 - 160 words'], 'optStatus': 'Complete', 'license': 'Creative Commons Attribution (CC BY)', 'lastPublishedOn': '2016-06-28T13:37:30.677+0000', 'size': 5879186, 'concepts': [], 'domain': ['literacy'], 'me_averageSessionsPerDevice': 4, 'name': 'छेद', 'publisher': '', 'status': 'Live', 'template': 'domain_3946', 'me_averageInteractionsPerMin': 14.86, 'code': 'org.ekstep.literacy.story.269', 'me_totalSessionsCount': 68, 'methods': [], 'imageCredits': ['EkStep'], 'description': 'इस कहानी में दो दोस्त अज्जू और गज्जू संकट में फस जाते हैं । आगे पढ़िए कि बचने के लिए उन्होंने क्या तरकीब निकाली। कहानी उन बच्चों के लिए है जो अभी वाकय पढ़ना शुरू कर रहे हैं। कहानी अपनी आवाज़ में रिकॉर्ड करें और सुनें। कहानी के अंत में कुछ सवाल हैं जो कहानी की समझ परखते हैं।', 'idealScreenSize': 'normal', 'createdOn': '2016-11-16T11:09:21.973+0000', 'me_totalSideloads': 2, 'me_totalComments': 0, 'popularity': 10706.04, 'contentDisposition': 'inline', 'genre': ['Fiction'], 'lastUpdatedOn': '2017-05-15T07:03:33.527+0000', 'me_totalDevices': 17, 'owner': 'Pratham', 'me_totalDownloads': 47, 'creator': 'Pratham', 'os': ['All'], 'soundCredits': ['freesound.org - author: http://bit.ly/1UccYtt', 'soundbible.com - author: http://soundbible.com/1343-Jump.html'], 'libraries': [], 'me_totalInteractions': 2651, 'pkgVersion': 15, 'versionKey': '1496647150471', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/domain_4127_1467121049922.ecar', 'me_averageRating': 3.42, 'lastSubmittedOn': '2016-06-28T12:44:14.476+0000', 'createdBy': '366', 'compatibilityLevel': 1, 'developer': 'EkStep'}, {'copyright': '', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_20052524/testing-flag_1481115299431_do_20052524_1.0.ecar', 'language': ['English'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'source': '', 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_20052524/artifact/de58f590da1146b3b48a1b0db6161029_1470399251238.thumb.png', 'gradeLevel': ['Grade 1'], 'collections': [{'identifier': 'do_2122676615775764481183', 'name': 'Copied From Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_20052190', 'name': 'Collection  test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Collection  test Collection  test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'appId': 'qa.ekstep.in', 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_20052524/artifact/1481115299108_do_20052524.zip', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-12T05:30:21.057+0000', 'contentType': 'Story', 'lastUpdatedBy': '273', 'identifier': 'do_20052524', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '273', 'index': 43, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'ageGroup': ['5-6'], 'lastPublishedOn': '2016-12-07T12:54:59.618+0000', 'size': 68025, 'concepts': [{'identifier': 'LO45', 'name': 'Comprehension Of Essays', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Comprehension Of Essays', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'domain': ['literacy'], 'name': 'Testing flag', 'publisher': '', 'status': 'Live', 'template': 'do_20043409', 'code': 'org.ekstep.literacy.story.3107', 'imageCredits': ['Sumangala GM'], 'description': 'testing', 'idealScreenSize': 'normal', 'posterImage': 'https://qa.ekstep.in/assets/public/content/de58f590da1146b3b48a1b0db6161029_1470399251238.png', 'createdOn': '2016-12-05T13:20:32.050+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-05-15T07:09:30.086+0000', 'owner': 'Umesh Thorat Tekdi', 'creator': 'Umesh Thorat Tekdi', 'os': ['All'], 'pkgVersion': 1, 'versionKey': '1497245421057', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_20052524/testing-flag_1481115299431_do_20052524_1.0.ecar', 'lastSubmittedOn': '2016-12-07T12:53:42.522+0000', 'createdBy': '273', 'compatibilityLevel': 1}], 'appId': 'qa.ekstep.in', 'contentEncoding': 'gzip', 'contentType': 'Collection', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-06-14T06:54:04.230+0000', 'lastUpdatedBy': '325', 'identifier': 'do_20052190', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'portalOwner': '273', 'index': 2, 'mediaType': 'Content', 'osId': 'org.ekstep.quiz.app', 'ageGroup': ['6-7', '7-8', '<5', '>10', '5-6', '8-10'], 'lastPublishedBy': '325', 'tags': ['tes'], 'prevState': 'Review', 'lastPublishedOn': '2017-06-14T06:53:47.554+0000', 'size': 47376297, 'concepts': [{'identifier': 'LO47', 'name': 'Comprehension Of Poems', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Comprehension Of Poems', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'LO53', 'name': 'Word Context', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Accurate Word For Context', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'LO52', 'name': 'More Than One Meaning', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'More Than One Meaning', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'Num:C3:SC1', 'name': 'Addition/subtraction', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Addition/subtraction', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'LO37', 'name': 'Tracing Akshara', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Tracing Akshara', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'C7', 'name': 'Sequence', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Compare, order and arrange numbers; mental number line; properties of numbers (odd, even, squares, etc.)', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'LO14', 'name': 'Syllable Awareness', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Syllable Awareness', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'LO7', 'name': 'Decoding for Reading', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Decoding for Reading', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'C8', 'name': 'Place value', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Vocabulary of place value, understanding ones, tens and higher digit place values, expansion of numbers', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'LO45', 'name': 'Comprehension Of Essays', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Comprehension Of Essays', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'LO39', 'name': 'Akshara Recognition', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Akshara Recognition', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'LO16', 'name': 'Onset-Coda Awareness', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Onset-Coda Awareness', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'domain': ['literacy', 'numeracy'], 'name': 'Collection  test', 'publisher': '', 'status': 'Live', 'template': '', 'code': 'org.ekstep.literacy.collection.2925', 'description': 'Collection  test Collection  test', 'medium': '', 'posterImage': 'https://qa.ekstep.in/assets/public/content/c43943b4c5001b62a64dd63e897d3a61_1475832877688.jpeg', 'idealScreenSize': 'normal', 'createdOn': '2016-11-08T14:31:14.204+0000', 'screenshots': ['https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212265452819267584126/artifact/f2f6d4dda7d23f50bdf4f20a78b43d12_1497247658637.jpeg', 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212265469015105536148/artifact/dd51b40a53f3ee87ace9c8561afb31eb_1497249635671.jpeg', 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212263343718334464147/artifact/bbba040bf70843eebe5bbac222697282_1496990200038.jpeg', 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212260506574987264115/artifact/23b3ddde84eaa2d0bbff143d52a2bff3_1496643869056.jpeg'], 'contentDisposition': 'inline', 'genre': ['Picture Books', 'Chapter Books', 'Fiction'], 'lastUpdatedOn': '2017-06-14T06:54:05.166+0000', 'theme': ['Geography', 'Art', 'Funny'], 'owner': 'Umesh Thorat Tekdi', 'creator': 'Umesh Thorat Tekdi', 'os': ['All'], 'pkgVersion': 1, 'versionKey': '1497423245166', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_20052190/collection-test_1497423235659_do_20052190_1.0.ecar', 'createdBy': '273', 'compatibilityLevel': 1}, {'subject': 'Assamese', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_2123200645109104641656/mp4-content_1503914254687_do_2123200645109104641656_1.0.ecar', 'channel': 'in.ekstep', 'language': ['English'], 'variants': {'spine': {'ecarUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_2123200645109104641656/mp4-content_1503914255276_do_2123200645109104641656_1.0_spine.ecar', 'size': 1000}}, 'mimeType': 'video/mp4', 'gradeLevel': ['Grade 4'], 'collections': [{'identifier': 'do_2123248707513630721382', 'name': 'logu test course', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test desc', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212345541699534848166', 'name': 'Note test course', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Note test course', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123222510609940481113', 'name': 'test the leaf nodes', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'children': [], 'usesContent': [], 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_2123200645109104641656/artifact/redirected-to-dashboard_1503914126049.mp4', 'contentEncoding': 'identity', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-08-28T09:57:35.463+0000', 'contentType': 'Story', 'item_sets': [], 'lastUpdatedBy': '68777b59-b28b-4aee-88d6-50d46e4c3509', 'identifier': 'do_2123200645109104641656', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': 'fa271a76-c15a-4aa1-adff-31dd04682a1f', 'index': 3, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'lastPublishedBy': '68777b59-b28b-4aee-88d6-50d46e4c3509', 'prevState': 'Review', 'size': 1802076, 'lastPublishedOn': '2017-08-28T09:57:34.686+0000', 'concepts': [], 'name': 'MP4 Content', 'status': 'Live', 'code': 'org.sunbird.uUT4lK', 'methods': [], 'description': 'Test content uploaded by Creator user', 'medium': 'Kannada', 'idealScreenSize': 'normal', 'createdOn': '2017-08-28T09:55:24.866+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-08-28T09:56:25.987+0000', 'createdFor': ['01232002070124134414'], 'creator': 'CreatorUser', 'os': ['All'], 'libraries': [], 'pkgVersion': 1, 'versionKey': '1503914255464', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_2123200645109104641656/mp4-content_1503914254687_do_2123200645109104641656_1.0.ecar', 'lastSubmittedOn': '2017-08-28T09:56:25.980+0000', 'createdBy': '2aade7d9-6abf-433b-9a05-3b02cd2eb664', 'compatibilityLevel': 1}, {'subject': 'Assamese', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_2123200632760729601651/pdf-content_1503914286281_do_2123200632760729601651_1.0.ecar', 'channel': 'in.ekstep', 'language': ['English'], 'variants': {'spine': {'ecarUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_2123200632760729601651/pdf-content_1503914287035_do_2123200632760729601651_1.0_spine.ecar', 'size': 1011}}, 'mimeType': 'application/pdf', 'gradeLevel': ['Grade 5'], 'collections': [{'identifier': 'do_212345541699534848166', 'name': 'Note test course', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Note test course', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123248707513630721382', 'name': 'logu test course', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test desc', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'children': [], 'usesContent': [], 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_2123200632760729601651/artifact/i-still-cant-speak-english_1503913977504.pdf', 'contentEncoding': 'identity', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-08-28T09:58:07.196+0000', 'contentType': 'Story', 'item_sets': [], 'lastUpdatedBy': '68777b59-b28b-4aee-88d6-50d46e4c3509', 'identifier': 'do_2123200632760729601651', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': 'fa271a76-c15a-4aa1-adff-31dd04682a1f', 'index': 5, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'lastPublishedBy': '68777b59-b28b-4aee-88d6-50d46e4c3509', 'prevState': 'Review', 'size': 5474365, 'lastPublishedOn': '2017-08-28T09:58:06.281+0000', 'concepts': [], 'name': 'PDF Content', 'status': 'Live', 'code': 'org.sunbird.P4lvDp', 'methods': [], 'description': 'Test content uploaded by Creator user', 'medium': 'Hindi', 'idealScreenSize': 'normal', 'createdOn': '2017-08-28T09:52:54.130+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-08-28T09:53:36.924+0000', 'createdFor': ['01232002070124134414'], 'creator': 'CreatorUser', 'os': ['All'], 'libraries': [], 'pkgVersion': 1, 'versionKey': '1503914287196', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_2123200632760729601651/pdf-content_1503914286281_do_2123200632760729601651_1.0.ecar', 'lastSubmittedOn': '2017-08-28T09:53:36.812+0000', 'createdBy': '2aade7d9-6abf-433b-9a05-3b02cd2eb664', 'compatibilityLevel': 4}, {'code': 'sunbird.content.9077887888676766454', 'methods': [], 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_2122868143795896321257/pdf-new_1499855609825_do_2122868143795896321257_1.0.ecar', 'description': 'pdf new', 'language': ['English'], 'variants': {'spine': {'ecarUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_2122868143795896321257/pdf-new_1499855609962_do_2122868143795896321257_1.0_spine.ecar', 'size': 732}}, 'mimeType': 'application/pdf', 'idealScreenSize': 'normal', 'createdOn': '2017-07-12T10:27:50.946+0000', 'collections': [{'identifier': 'do_2122913271822909441270', 'name': 'Course 1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Description', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212345541699534848166', 'name': 'Note test course', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Note test course', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2122881050396508161323', 'name': 'youtube new', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'youtube new', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'children': [], 'appId': 'qa.ekstep.in', 'usesContent': [], 'contentDisposition': 'inline', 'contentEncoding': 'identity', 'artifactUrl': 'https://ekstep-public-dev.s3-ap-south-1.amazonaws.com/content/do_11221614362209484814/artifact/pdf_1491228505073.pdf', 'lastUpdatedOn': '2017-07-12T10:32:55.519+0000', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-07-12T10:33:30.330+0000', 'contentType': 'Story', 'item_sets': [], 'owner': 'EkStep', 'identifier': 'do_2122868143795896321257', 'audience': ['Learner'], 'os': ['All'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'libraries': [], 'index': 6, 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'pkgVersion': 1, 'versionKey': '1499855610330', 'prevState': 'Draft', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_2122868143795896321257/pdf-new_1499855609825_do_2122868143795896321257_1.0.ecar', 'lastPublishedOn': '2017-07-12T10:33:29.825+0000', 'size': 412514, 'concepts': [], 'compatibilityLevel': 4, 'name': 'pdf new', 'status': 'Live'}, {'subject': 'Assamese', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212297340149383168148/mp4_1501826325413_do_212297340149383168148_1.0.ecar', 'language': ['English'], 'variants': {'spine': {'ecarUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_212297340149383168148/mp4_1501826325873_do_212297340149383168148_1.0_spine.ecar', 'size': 952}}, 'mimeType': 'video/mp4', 'gradeLevel': ['Kindergarten'], 'collections': [{'identifier': 'do_212322976183574528152', 'name': 'test flow course', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'wdad', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123159215287828481351', 'name': 'Unit 1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Unit 1', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123152021555691521266', 'name': 'Preview testing', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': null, 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212312305393213440170', 'name': 'test my course', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test desc', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123248707513630721382', 'name': 'logu test course', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test desc', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212345541699534848166', 'name': 'Note test course', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Note test course', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'children': [], 'usesContent': [], 'contentEncoding': 'identity', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212297340149383168148/artifact/recording-987_1501140155969.mp4', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-08-04T05:58:46.002+0000', 'contentType': 'Story', 'item_sets': [], 'lastUpdatedBy': '412f0550-c946-425b-822f-08e4f14df80e', 'identifier': 'do_212297340149383168148', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': 'fa271a76-c15a-4aa1-adff-31dd04682a1f', 'index': 4, 'mediaType': 'content', 'ageGroup': ['<5'], 'osId': 'org.ekstep.quiz.app', 'lastPublishedBy': '412f0550-c946-425b-822f-08e4f14df80e', 'languageCode': 'en', 'prevState': 'Review', 'lastPublishedOn': '2017-08-04T05:58:45.413+0000', 'size': 1860732, 'concepts': [], 'name': 'Mp4', 'status': 'Live', 'code': 'org.sunbird.DeMppv', 'methods': [], 'description': 'upload', 'medium': 'Assamese', 'idealScreenSize': 'normal', 'createdOn': '2017-07-27T07:22:34.953+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-08-01T10:21:04.823+0000', 'channelId': 'sunbird', 'createdFor': ['sunbird'], 'os': ['All'], 'libraries': [], 'pkgVersion': 1, 'versionKey': '1501826326002', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_212297340149383168148/mp4_1501826325413_do_212297340149383168148_1.0.ecar', 'createdBy': '107240bc-918c-4e42-9545-4f8d596ee24e', 'compatibilityLevel': 1}, {'keywords': ['sdf'], 'subject': '', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_2122930846500618241127/collaboration-test_1500621629524_do_2122930846500618241127_1.0.ecar', 'channel': 'in.ekstep', 'language': ['Assamese'], 'mimeType': 'application/vnd.ekstep.content-collection', 'variants': {'spine': {'ecarUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_2122930846500618241127/collaboration-test_1500621629694_do_2122930846500618241127_1.0_spine.ecar', 'size': 48929}}, 'source': '', 'gradeLevel': ['Grade 1'], 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_2122882457993052161359/artifact/assetstux-48x48_690_1500030054_1500030004841.png', 'collections': [{'identifier': 'do_21231287394414592018', 'name': 'Test unit 1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'hsdfjshfjhsfsj', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123250220546949121517', 'name': 'Re2', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'qazwsx', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123248707513630721382', 'name': 'logu test course', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test desc', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2122937343671091201187', 'name': 'Unit 1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'First Unit', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123250333924556801545', 'name': 'Shi2', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'jn j', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123222510609940481113', 'name': 'test the leaf nodes', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212345541699534848166', 'name': 'Note test course', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Note test course', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_21231293487797862411', 'name': 'Test title', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'This is a test book', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123213382021857281810', 'name': 'vgvg', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'knk', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212312287059542016160', 'name': 'Testtextbook', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test description', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212322976183574528152', 'name': 'test flow course', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'wdad', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'children': [{'subject': '', 'channel': 'in.ekstep', 'downloadUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_21228031946955980819/test-review-process_1499851249497_do_21228031946955980819_1.0.ecar', 'language': ['Assamese'], 'mimeType': 'application/vnd.ekstep.ecml-archive', 'variants': {'spine': {'ecarUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/ecar_files/do_21228031946955980819/test-review-process_1499851249759_do_21228031946955980819_1.0_spine.ecar', 'size': 43747}}, 'source': '', 'editorState': '{"plugin":{"noOfExtPlugins":2,"extPlugins":[{"plugin":"org.ekstep.ceheader","version":"1.0"},{"plugin":"org.ekstep.keyboardshortcuts","version":"1.0"}]},"stage":{"noOfStages":1,"currentStage":"8a06990a-6e12-43d6-bddb-594650295134"},"sidebar":{"selectedMenu":"settings"}}', 'appIcon': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_21228031946955980819/artifact/b2e046aac35b1661967cc7e5cd227bbd_1499850743161.thumb.jpeg', 'gradeLevel': ['Grade 1'], 'collections': [{'identifier': 'do_212296660663975936121', 'name': 'Collection is saving', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test collection is saving', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212297500449210368199', 'name': 'test Unit', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123250179409756161507', 'name': 'dash2', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'nmk', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2122930846500618241127', 'name': 'collaboration test', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Testing', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123171405705707521479', 'name': 'JP Course 1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Test content uploaded by Creator user', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_2123165037383761921419', 'name': 'AyubBasha_23082017', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'Sanity Testing', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212306481425145856180', 'name': 'bhbg', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'qw', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'do_212303071383044096189', 'name': 'Bengali 1', 'objectType': 'Content', 'relation': 'hasSequenceMember', 'description': 'test', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'appId': 'qa.ekstep.in', 'contentEncoding': 'gzip', 'artifactUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_21228031946955980819/artifact/1499062459032_do_21228031946955980819.zip', 'contentType': 'Worksheet', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-07-12T09:20:50.066+0000', 'lastUpdatedBy': '129', 'identifier': 'do_21228031946955980819', 'audience': ['Learner'], 'visibility': 'Default', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'index': 0, 'mediaType': 'content', 'ageGroup': ['5-6', '6-7'], 'osId': 'org.ekstep.quiz.app', 'lastPublishedBy': '129', 'prevState': 'Review', 'lastPublishedOn': '2017-07-12T09:20:49.497+0000', 'size': 44312, 'concepts': [{'identifier': 'Num:C3:SC8', 'name': 'Compares fractions', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Compares fractions', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}, {'identifier': 'Num:C3:SC9', 'name': 'Division/Multiplication', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Division/Multiplicatio', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'domain': ['numeracy'], 'name': 'Test review process', 'publisher': '', 'attributions': [''], 'status': 'Live', 'template': '', 'code': 'org.ekstep.numeracy.worksheet.7205', 'description': 'Test review process test test', 'medium': '', 'posterImage': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_2122867772876800001216/artifact/b2e046aac35b1661967cc7e5cd227bbd_1499850743161.jpeg', 'idealScreenSize': 'normal', 'createdOn': '2017-07-03T06:13:55.249+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-07-12T09:19:12.176+0000', 'owner': 'Bajaj', 'createdFor': [''], 'creator': 'Gouri Shanker Bajaj', 'os': ['All'], 'pkgVersion': 1, 'versionKey': '1499851250066', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_21228031946955980819/test-review-process_1499851249497_do_21228031946955980819_1.0.ecar', 'createdBy': '749', 'compatibilityLevel': 2, 'organization': ['']}], 'contentEncoding': 'gzip', 'collaborators': ['325'], 'mimeTypesCount': '{"application/vnd.ekstep.ecml-archive":1}', 'contentType': 'Collection', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-07-21T07:20:29.850+0000', 'lastUpdatedBy': '501', 'identifier': 'do_2122930846500618241127', 'audience': ['Learner'], 'collectionPlayerCtrl_url': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_2122930846500618241127/artifact/do_2122930846500618241127collectionPlayerCtrl.json', 'visibility': 'Default', 'contentTypesCount': '{"Worksheet":1}', 'consumerId': '2c43f136-c02f-4494-9fb9-fd228e2c77e6', 'index': 1, 'mediaType': 'Content', 'ageGroup': ['6-7', '5-6'], 'osId': 'org.ekstep.quiz.app', 'lastPublishedBy': '501', 'tags': ['sdf'], 'prevState': 'Review', 'lastPublishedOn': '2017-07-21T07:20:28.359+0000', 'size': 49495, 'concepts': [{'identifier': 'C625', 'name': 'Add without conversion', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Add without conversion', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'domain': ['numeracy'], 'name': 'collaboration test', 'publisher': '', 'status': 'Live', 'template': '', 'code': 'org.ekstep.numeracy.collection.7456', 'description': 'Testing', 'medium': '', 'idealScreenSize': 'normal', 'createdOn': '2017-07-21T07:04:44.821+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-07-21T07:20:56.068+0000', 'creator': 'Umesh Thorat Tekdi', 'os': ['All'], 'pkgVersion': 1, 'versionKey': '1500621656068', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_2122930846500618241127/collaboration-test_1500621629524_do_2122930846500618241127_1.0.ecar', 'createdBy': '273', 'leafNodesCount': 1, 'compatibilityLevel': 1}], 'appId': 'sunbird.portal', 'contentEncoding': 'gzip', 'mimeTypesCount': '{"application/pdf":2,"application/vnd.ekstep.content-collection":2,"application/vnd.ekstep.ecml-archive":23,"video/mp4":2}', 'contentType': 'Course', 'sYS_INTERNAL_LAST_UPDATED_ON': '2017-09-20T15:58:56.508+0000', 'lastUpdatedBy': 'Amit Kumar', 'identifier': 'do_212345541699534848166', 'audience': ['Learner'], 'collectionPlayerCtrl_url': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212345541699534848166/artifact/do_212345541699534848166collectionPlayerCtrl.json', 'visibility': 'Default', 'contentTypesCount': '{"Worksheet":1,"Collection":2,"Story":26}', 'consumerId': 'fa271a76-c15a-4aa1-adff-31dd04682a1f', 'mediaType': 'content', 'osId': 'org.ekstep.quiz.app', 'lastPublishedBy': '349', 'size': 56233379, 'lastPublishedOn': '2017-09-20T05:30:41.106+0000', 'concepts': [{'identifier': 'SC9', 'name': 'Evolution', 'objectType': 'Concept', 'relation': 'associatedTo', 'description': 'Evolution', 'index': null, 'status': null, 'depth': null, 'mimeType': null, 'visibility': null}], 'name': 'Note test course', 'status': 'Flagged', 'code': 'org.sunbird.wRtejw', 'description': 'Note test course', 'lastFlaggedOn': '2017-09-27T06:42:01.601+0000', 'flaggedBy': ['Amit Kumar'], 'idealScreenSize': 'normal', 'posterImage': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/1q12_330_1467701049_1467701049228.png', 'createdOn': '2017-09-20T05:27:40.304+0000', 'contentDisposition': 'inline', 'lastUpdatedOn': '2017-09-27T06:42:01.604+0000', 'createdFor': ['ORG_001'], 'creator': 'AmitKumar', 'flagReasons': ['Inappropriate content'], 'os': ['All'], 'pkgVersion': 1, 'versionKey': '1506494521604', 'idealScreenDensity': 'hdpi', 's3Key': 'ecar_files/do_212345541699534848166/note-test-course_1505885449121_do_212345541699534848166_1.0.ecar', 'lastSubmittedOn': '2017-09-20T05:32:41.258+0000', 'createdBy': 'c7e35899-2ed1-47ad-9338-b1d8e2170483', 'compatibilityLevel': 4, 'leafNodesCount': 27, 'usedByContent': [], 'board': 'UP Board', 'resourceType': 'Story'}}},
    courseHierarchyFailedResponse = {'id': 'api.course.hierarchy', 'ver': '1.0', 'ts': '2017-09-28T09:11:55.892Z', 'params': {'resmsgid': '13181b40-a42d-11e7-bfbf-79d3eb8b325a', 'msgid': null, 'status': 'failed', 'err': 'ERR_COURSE_HIERARCHY_FAILED', 'errmsg': 'Get course hierarchy failed'}, 'responseCode': 'RESOURCE_NOT_FOUND', 'result': {}},
    contentStateResponse = [{'lastAccessTime': '2017-09-26 13:40:21:141+0000', 'contentId': 'do_2123200645109104641656', 'batchId': '01233621966349107211', 'completedCount': 1, 'result': null, 'score': null, 'grade': null, 'progress': 100, 'id': '7ec65f4a8189a3b26af56e77a4bcf82971aae5193f5d8217ca4c7c6941de8d32', 'viewCount': 2, 'contentVersion': null, 'courseId': 'do_212345541699534848166', 'lastCompletedTime': '2017-09-26 13:40:21:535+0000', 'status': 2}, {'lastAccessTime': '2017-09-26 14:32:48:507+0000', 'contentId': 'do_212262876810362880123', 'batchId': '01233621966349107211', 'completedCount': 1, 'result': null, 'score': null, 'grade': null, 'progress': 100, 'id': '1e5323d91c41f03cb1f1255956599b86e122672863693dba843dbf09625f6836', 'viewCount': 2, 'contentVersion': null, 'courseId': 'do_212345541699534848166', 'lastCompletedTime': '2017-09-26 14:32:48:754+0000', 'status': 2}, {'lastAccessTime': '2017-09-26 19:10:33:633+0530', 'contentId': 'do_20052524', 'batchId': '01233621966349107211', 'completedCount': 0, 'result': null, 'score': null, 'grade': null, 'progress': 3, 'id': '3e193565aacda32f39165cd427dfe4e5d6ea1f611ae90fcf127cf5eb2bd220e2', 'viewCount': 1, 'contentVersion': null, 'courseId': 'do_212345541699534848166', 'lastCompletedTime': null, 'status': 1}, {'lastAccessTime': '2017-09-26 13:41:51:036+0000', 'contentId': 'do_21228031946955980819', 'batchId': '01233621966349107211', 'completedCount': 1, 'result': null, 'score': null, 'grade': null, 'progress': 100, 'id': 'c8be6d3f733a7ea585fd13e3004dd30b84a69967706e4fb8d014d151135e1e78', 'viewCount': 2, 'contentVersion': null, 'courseId': 'do_212345541699534848166', 'lastCompletedTime': '2017-09-26 13:41:51:321+0000', 'status': 2}],
    batchServiceResponse = {'id': 'api.course.batch.read', 'ver': 'v1', 'ts': '2017-10-11 10:17:11:018+0000', 'params': {'resmsgid': null, 'msgid': 'b2f7de92-ec13-4907-a81f-134ab8b61b70', 'err': null, 'status': 'success', 'errmsg': null}, 'responseCode': 'OK', 'result': {'response': {'identifier': '0123455555175464967', 'createdFor': ['0123164136298905609', 'ORG_001'], 'courseAdditionalInfo': {'courseName': 'course oct test', 'leafNodesCount': '13', 'description': 'test course for oct release', 'courseLogoUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212345541699534848166/artifact/b5c2ff92ab5512754a24b7ed0a09e97f_1478082514640.thumb.jpeg', 'collectionPlayerCtrlUrl': 'https://ekstep-public-qa.s3-ap-south-1.amazonaws.com/content/do_212345541699534848166/artifact/do_212345541699534848166collectionPlayerCtrl.json', 'status': 'Live'}, 'endDate': '2017-11-01', 'countIncrementStatus': false, 'createdDate': '2017-10-03 10:11:49:639+0000', 'hashtagid': '0123455555175464967', 'createdBy': '1aa3565c-7f8f-4c6b-bc71-c6a3a7c172dc', 'courseCreator': '1aa3565c-7f8f-4c6b-bc71-c6a3a7c172dc', 'mentors': [], 'name': 'oct batch 1', 'countDecrementStatus': false, 'id': '0123455555175464967', 'enrollmentType': 'open', 'courseId': 'do_212345541699534848166', 'startDate': '2017-10-03', 'status': 1}}}
  beforeEach(inject(function ($rootScope, _$stateParams_, _courseService_, _$timeout_,
    _$state_, _$q_, $controller) {
    rootScope = $rootScope
    $stateParams = _$stateParams_
    courseService = _courseService_
    $timeout = _$timeout_
    scope = $rootScope.$new()
    $state = _$state_
    $q = _$q_
    deferred = _$q_.defer()
    collectionPlayerCtrl = new $controller('CollectionPlayerCtrl', {$scope: scope, $rootScope: rootScope})
  }))

  it('should load course hierarchy', function () {
    var res = {result: {content: {status: 'Live'}}}
    spyOn(courseService, 'courseHierarchy').and.returnValue(deferred.promise)
    deferred.resolve(courseHierarchyResponse)
    spyOn(collectionPlayerCtrl, 'loadData').and.callThrough()
    collectionPlayerCtrl.loadData()
    scope.$apply()
    var response = courseService.courseHierarchy().$$state.value
    expect(response).not.toBe(undefined)
    collectionPlayerCtrl.getCoursecollectionPlayerCtrl = response.result.content
    expect(collectionPlayerCtrl.getCoursecollectionPlayerCtrl).toBeDefined()
  })

  it('should not load course hierarchy', function () {
    spyOn(courseService, 'courseHierarchy').and.returnValue(deferred.promise)
    deferred.reject({})
    spyOn(collectionPlayerCtrl, 'loadData').and.callThrough()
    collectionPlayerCtrl.loadData()
    scope.$apply()
    var response = courseService.courseHierarchy().$$state.value
    expect(response).not.toBe(undefined)
  })

  it('should construct tree', function () {
    spyOn(collectionPlayerCtrl, 'constructTree').and.callThrough()
    console.log('collectionPlayerCtrl.getCoursecollectionPlayerCtrl', collectionPlayerCtrl.getCoursecollectionPlayerCtrl)
    collectionPlayerCtrl.constructTree(1, collectionPlayerCtrl.getCoursecollectionPlayerCtrl)
    scope.$apply()
  })

  it('should initialize fancy tree', function () {
    spyOn(collectionPlayerCtrl, 'initializeFancyTree').and.callThrough()
    collectionPlayerCtrl.initializeFancyTree('23423423423423423', '23')
    $timeout.flush()
    scope.$apply()
  })

  it('should expand the tree', function () {
    spyOn(collectionPlayerCtrl, 'expandMe').and.callThrough()
    collectionPlayerCtrl.expandMe('23423423423423423', '23')
    scope.$apply()
  })

  it('should expand the tree', function () {
    spyOn(collectionPlayerCtrl, 'expandMe').and.callThrough()
    collectionPlayerCtrl.expandMe('2', {'mimeType': 'application/vnd.ekstep.ecml-archive'})
    scope.$apply()
  })

  it('should return related mimetype icon', function () {
    spyOn(collectionPlayerCtrl, 'getContentIcon').and.callThrough()
    var icon = collectionPlayerCtrl.getContentIcon('application/pdf')
    expect(icon).toEqual('large file pdf outline icon')
    scope.$apply()
  })

  it('should update icon', function () {
    spyOn(collectionPlayerCtrl, 'updateIcon').and.callThrough()
    collectionPlayerCtrl.updateIcon('large file pdf outline icon', false)
    scope.$apply()
  })

  it('should play content', function () {
    spyOn(collectionPlayerCtrl, 'playContent').and.callThrough()
    collectionPlayerCtrl.playContent({identifier: '2342342342423423'})
    scope.$apply()
  })

  it('should play content', function () {
    spyOn(collectionPlayerCtrl, 'closePlayer').and.callThrough()
    $stateParams.backState = 'Profile'
    collectionPlayerCtrl.closePlayer()
    scope.$apply()
  })

  it('should play content', function () {
    spyOn(collectionPlayerCtrl, 'closePlayer').and.callThrough()
    rootScope.search = {}
    rootScope.search.searchKeyword = 'sdfsdfs'
    collectionPlayerCtrl.closePlayer()
    $timeout.flush()
    scope.$apply()
  })

  it('should play content', function () {
    spyOn(collectionPlayerCtrl, 'closePlayer').and.callThrough()
    rootScope.search = {}
    rootScope.search.searchKeyword = ''
    $stateParams.backState === 'Resource'
    collectionPlayerCtrl.closePlayer()
    scope.$apply()
  })

  it('should call applyAccordion', function () {
    spyOn(collectionPlayerCtrl, 'applyAccordion').and.callThrough()
    collectionPlayerCtrl.applyAccordion()
    $timeout.flush(100)
    scope.$apply()
  })

  it('should call getTreeData', function () {
    var contentData = {'mimeType': 'application/vnd.ekstep.ecml-archive'}
    var parent = []
    spyOn(collectionPlayerCtrl, 'getTreeData').and.callThrough()
    collectionPlayerCtrl.getTreeData(contentData, parent)
    scope.$apply()
  })

  it('should call getTreeData', function () {
    var contentData = {'mimeType': 'application/vnd.ekstep.content-collection'}
    var parent = []
    spyOn(collectionPlayerCtrl, 'getTreeData').and.callThrough()
    collectionPlayerCtrl.getTreeData(contentData, parent)
    scope.$apply()
  })
})
